package arabiannight.tistory.com.alarmmanager;

import android.app.Activity;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class TestAlarmManagerActivity extends Activity implements OnClickListener{
	
	private static final String TAG = "TestAlarmManagerActivity";
	private static final String INTENT_ACTION = "arabiannight.tistory.com.alarmmanager";
	
    @Override
    public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        setLayout();
        
    }

	@Override
	public void onClick(View v){
		switch (v.getId()) {
		case R.id.btn_set_alarm:
			setAlarm(this, 5000);
			Toast.makeText(getApplicationContext(), "setAlarm()", Toast.LENGTH_SHORT).show();
			break;
			
		case R.id.btn_release_alarm:
			releaseAlarm(this);
			Toast.makeText(getApplicationContext(), "releaseAlarm()", Toast.LENGTH_SHORT).show();
			break;

		default:
			break;
		}
	}
	
	// 알람 등록
	private void setAlarm(Context context, long second){  
		Log.i(TAG, "setAlarm()"); 
		AlarmManager alarmManager = (AlarmManager)context.getSystemService(Context.ALARM_SERVICE);

		Intent Intent = new Intent(INTENT_ACTION);
		PendingIntent pIntent = PendingIntent.getActivity(context, 0, Intent, 0);
		
		alarmManager.set(AlarmManager.RTC, System.currentTimeMillis() + second, pIntent);
	}
	
	// 알람 해제
	private void releaseAlarm(Context context){  
		Log.i(TAG, "releaseAlarm()"); 
		AlarmManager alarmManager = (AlarmManager)context.getSystemService(Context.ALARM_SERVICE);

		Intent Intent = new Intent(INTENT_ACTION);
		PendingIntent pIntent = PendingIntent.getActivity(context, 0, Intent, 0);
		alarmManager.cancel(pIntent);
		
		// 주석을 풀면 먼저 실행되는 알람이 있을 경우, 제거하고
		// 새로 알람을 실행하게 된다. 상황에 따라 유용하게 사용 할 수 있다.
//		alarmManager.set(AlarmManager.RTC, System.currentTimeMillis() + 3000, pIntent);
	}
	
	/*
	 * Layout
	 */
	private Button[] mButtons;
	
	private void setLayout(){
		mButtons = new Button[]{
			(Button) findViewById(R.id.btn_set_alarm),
			(Button) findViewById(R.id.btn_release_alarm)
		};
		
		for(Button b : mButtons)
			b.setOnClickListener(this);
		
	}
	
}